# SoProfile Class Reference
[Nodes]

`#include <Inventor/nodes/SoProfile.h>`

Inheritance diagram for SoProfile:

List of all members.

## Detailed Description

The SoProfile class is the abstract superclass for profile definitions.

Node subclasses of SoProfile specifies profiles for extruded 3D text and nurbs surface data.

## Public Types

enum | Profile { START_FIRST = SoProfileElement::START_FIRST, START_NEW = SoProfileElement::START_NEW, ADD_TO_CURRENT = SoProfileElement::ADD_TO_CURRENT }

## Public Member Functions

virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | getTrimCurve (SoState *state, int32_t &numpoints, float *&points, int &floatspervec, int32_t &numknots, float *&knotvector)=0
virtual void | getVertices (SoState *state, int32_t &numvertices, SbVec2f *&vertices)=0

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFInt32 | index
SoSFEnum | linkage

## Protected Member Functions

| SoProfile (void)
virtual | ~SoProfile ()

## Member Enumeration Documentation

enum SoProfile::Profile

Enumeration of various choices of how to link together multiple profiles.

Enumeration values:

  START_FIRST | Replace the current profile state set with this profile alone.
  START_NEW | Append this profile to the state as a new profile.
  ADD_TO_CURRENT | Append indices of this node to the last profile.

## Constructor & Destructor Documentation

SoProfile::SoProfile | ( | void |  | ) | `[protected]`

| Constructor.

SoProfile::~SoProfile | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoProfile::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode. Reimplemented in SoLinearProfile, and SoNurbsProfile.

void SoProfile::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoProfile::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoProfile::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoProfile::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

void SoProfile::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoProfile::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

void SoProfile::getTrimCurve | ( | SoState * | state,
|  | int32_t & | numpoints,
|  | float *& | points,
|  | int & | floatspervec,
|  | int32_t & | numknots,
|  | float *& | knotvector
| ) | `[pure virtual]`

| Return points and knotvector of the state. Implemented in SoLinearProfile, and SoNurbsProfile.

void SoProfile::getVertices | ( | SoState * | state,
|  | int32_t & | numvertices,
|  | SbVec2f *& | vertices
| ) | `[pure virtual]`

| Return vertex set of state. Implemented in SoLinearProfile, and SoNurbsProfile.

## Member Data Documentation

SoMFInt32 SoProfile::index

| Profile coordinate indices. These must match what is available from previous SoProfileCoordinate2 and SoProfileCoordinate3 nodes in the traversal.

SoSFEnum SoProfile::linkage

| How the indices of this profile node should be combined with the current profile index set of the traversal state.

The documentation for this class was generated from the following files:

- SoProfile.h
- SoProfile.cpp